<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 06/29/2004 *
 * ================                             Last change: 02/11/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_rallyes.php                            *
 * -------------------------------------------------------------------- *
 * Short description : List existing rallyes                            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Bestehende Rallyes auflisten                     *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", __FILE__);

if (empty($_GET['sub'])) $_GET['sub'] = "";
$MSG = "";

// Quick actions on a rallye
if (isset($_GET['rallye']))
{
	// Activate / deactivate
	$SQL = "";
	if (isset($_GET['activate']))
	{
		switch ($_GET['activate'])
		{
		case "1": // Activate
			$SQL = "UPDATE "._MYSQL_PREFIX."_rallye_data SET is_active='Y' WHERE id=%s AND is_active='N' LIMIT 1";
			break;

		case "0": // Deactivate
			$SQL = "UPDATE "._MYSQL_PREFIX."_rallye_data SET is_active='N' WHERE id=%s AND is_active='Y' LIMIT 1";
			break;
		}
	}

	// Automatic notification
	if (isset($_GET['notify']))
	{
		switch ($_GET['notify'])
		{
		case "1": // Activate
			$SQL = "UPDATE "._MYSQL_PREFIX."_rallye_data SET send_notify='Y' WHERE id=%s AND send_notify='N' LIMIT 1";
			break;

		case "0": // Deactivate
			$SQL = "UPDATE "._MYSQL_PREFIX."_rallye_data SET send_notify='N' WHERE id=%s AND send_notify='Y' LIMIT 1";
			break;
		}
	}

	// Automatic adding of new members
	if (isset($_GET['auto']))
	{
		switch ($_GET['auto'])
		{
		case "1": // Activate
			$SQL = "UPDATE "._MYSQL_PREFIX."_rallye_data SET auto_add_new_user='Y' WHERE id=%s AND auto_add_new_user='N' LIMIT 1";
			break;

		case "0": // Deactivate
			$SQL = "UPDATE "._MYSQL_PREFIX."_rallye_data SET auto_add_new_user='N' WHERE id=%s AND auto_add_new_user='Y' LIMIT 1";
			break;
		}
	}

	// Run SQL command
	if (!empty($SQL))
	{
		$result = SQL_QUERY_ESC($SQL, array(bigintval($_GET['rallye'])), __FILE__, __LINE__);
	}
}
 elseif (isset($_POST['remove']))
{
	// Delete rallyes
	$SEL = SELECTION_COUNT($_POST['sel']);
	if ($SEL > 0)
	{
		// Delete selected rallyes and all it's data
		foreach ($_POST['sel'] as $id => $sel)
		{
			// Remove selected rallye entirely...
			$result = SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_rallye_data WHERE id=%s LIMIT 1",
			 array(bigintval($id)), __FILE__, __LINE__);
			$result = SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_rallye_prices WHERE rallye_id=%s",
			 array(bigintval($id)), __FILE__, __LINE__);
			$result = SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_rallye_users WHERE rallye_id=%s",
			 array(bigintval($id)), __FILE__, __LINE__);
		}

		// Output message
		$MSG = RALLYE_DELETED;
	}
	 else
	{
		// No rallye selected to delete!
		$MSG = RALLYE_DELETE_NOTHING_SELECTED;
	}
}
 elseif (isset($_POST['change']))
{
	// Change rallye
	$SEL = SELECTION_COUNT($_POST['title']);
	if ($SEL > 0)
	{
		// Change selected rallyes and all it's data
		foreach ($_POST['title'] as $id => $title)
		{
			// Secure ID number
			$id = bigintval($id);

			// Generate timestamps
			$START = mktime($_POST['start_hour'][$id], $_POST['start_min'][$id], $_POST['start_sec'][$id], $_POST['start_month'][$id], $_POST['start_day'][$id], $_POST['start_year'][$id]);
			$END   = mktime($_POST['end_hour'][$id]  , $_POST['end_min'][$id]  , $_POST['end_sec'][$id]  , $_POST['end_month'][$id]  , $_POST['end_day'][$id]  , $_POST['end_year'][$id]  );

			// Update entry
			$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_rallye_data SET
title='%s',
descr='%s',
template='%s',
start_time='%s',
end_time='%s',
min_users='%s',
min_prices='%s'
WHERE id='".$id."' LIMIT 1",
 array($title, $_POST['descr'][$id], $_POST['templ'][$id], bigintval($START), bigintval($END), bigintval($_POST['min_users'][$id]), bigintval($_POST['min_prices'][$id]), $id),
 __FILE__, __LINE__);
		}

		// Output message
		$MSG = RALLYE_CHANGED;
	}
}

if (isset($_POST['edit']))
{
	// Check for selections
	$SEL = SELECTION_COUNT($_POST['sel']);
	if ($SEL > 0)
	{
		// Make all selected and deactivated rallyes editable
		$SW = 2; $OUT = "";
		foreach ($_POST['sel'] as $id => $sel)
		{
			// Load rallye basic data
			$result = SQL_QUERY_ESC("SELECT title, descr, template, start_time, end_time, min_users, min_prices FROM "._MYSQL_PREFIX."_rallye_data WHERE id=%s LIMIT 1",
			 array(bigintval($id)), __FILE__, __LINE__);
			list($title, $descr, $templ, $start, $end, $min_users, $min_prices) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);

			// Starting day
			$content['s_sec']   = ADD_SELECTION("sec"  , date("s", $start), "start", $id);
			$content['s_min']   = ADD_SELECTION("min"  , date("i", $start), "start", $id);
			$content['s_hour']  = ADD_SELECTION("hour" , date("G", $start), "start", $id);
			$content['s_day']   = ADD_SELECTION("day"  , date("d", $start), "start", $id);
			$content['s_month'] = ADD_SELECTION("month", date("m", $start), "start", $id);
			$content['s_year']  = ADD_SELECTION("year" , date('Y', $start), "start", $id);

			// Ending day
			$content['e_sec']   = ADD_SELECTION("sec"  , date("s", $end)  , "end"  , $id);
			$content['e_min']   = ADD_SELECTION("min"  , date("i", $end)  , "end"  , $id);
			$content['e_hour']  = ADD_SELECTION("hour" , date("G", $end)  , "end"  , $id);
			$content['e_day']   = ADD_SELECTION("day"  , date("d", $end)  , "end"  , $id);
			$content['e_month'] = ADD_SELECTION("month", date("m", $end)  , "end"  , $id);
			$content['e_year']  = ADD_SELECTION("year" , date('Y', $end)  , "end"  , $id);

			// Remember over values
			$content['templ']      = RALLYE_TEMPLATE_SELECTION("templ[".$id."]", $templ);
			$content['sw']         = $SW;
			$content['id']         = $id;
			$content['title']      = $title;
			$content['descr']      = $descr;
			$content['min_users']  = $min_users;
			$content['min_prices'] = $min_prices;

			// Output row
			$OUT .= LOAD_TEMPLATE("admin_edit_rallyes_row", true, $content);

			// Color switching
			$SW = 3 - $SW;
		}
		// Remember rows in constant
		define('__RALLYE_ROWS', $OUT);

		// Load final template
		LOAD_TEMPLATE("admin_edit_rallyes");
	}
	 else
	{
		// Nothing selected to edit
		LOAD_TEMPLATE("admin_settings_saved", false, LOAD_TEMPLATE("admin_list_rallye_noselect", true));
	}
} elseif (($_GET['sub'] == "users") && ($_GET['rallye'] > 0)) {
	// List users and their refs before start and current
	$result = SQL_QUERY_ESC("SELECT userid, refs, curr_points FROM "._MYSQL_PREFIX."_rallye_users WHERE rallye_id=%s ORDER BY userid",
	 array(bigintval($_GET['rallye'])), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) > 0)
	{
		$SW = 2; $OUT = "";
		define('__RALLYE_VALUE', $_GET['rallye']);
		while (list($uid, $old, $opoints) = SQL_FETCHROW($result))
		{
			// Check for referal count
			$cnt = RALLYE_GET_REFCOUNT($uid, $old);

			// Output row
			$Bl = ""; $Br = "";
			if (($opoints > 0) && ($cnt > 0)) { $Bl = "<STRONG>"; $Br = "</STRONG>"; }
			if (($old > 0) || ($cnt > 0))
			{
				// Insert link to referal list
				//* DEBUG: */ echo "-".$uid."/".$cnt."/".$old."-<br />";
				$cnt = ADMIN_USER_PROFILE_LINK($uid, $cnt, "list_refs");
				$old = ADMIN_USER_PROFILE_LINK($uid, $old, "list_refs");
			}

			// Get user points
			$points = GET_TOTAL_DATA($uid, "user_points", "points", "userid", false, " AND ref_depth=1 LIMIT 1");
			//* DEBUG: */ echo basename(__FILE__).":uid={$uid},points={$points},opoints={$opoints}<br />\n";
			$content = array(
				'sw'      => $SW ,
				'uid'     => $uid,
				'bold_l'  => $Bl ,
				'bold_r'  => $Br ,
				'old'     => $old,
				'cnt'     => $cnt,
				'opoints' => TRANSLATE_COMMA($points - $opoints),
			);
			$OUT .= LOAD_TEMPLATE("admin_list_rallye_usr_row", true, $content);
			$SW = 3 - $SW;
		}

		// Free memory
		SQL_FREERESULT($result);
		define('__RALLYE_USER_ROWS', $OUT);

		// Load template
		LOAD_TEMPLATE("admin_list_rallye_usr");
	}
	 else
	{
		// No entries found?
		LOAD_TEMPLATE("admin_settings_saved", false, RALLYE_ADMIN_USERS_404);
	}
}
 else
{
	// Start listing rallyes
	$result = SQL_QUERY("SELECT id, admin_id, title, descr, template, start_time, end_time, auto_add_new_user, is_active, send_notify, notified, min_users, min_prices
FROM "._MYSQL_PREFIX."_rallye_data
ORDER BY start_time DESC",
 __FILE__, __LINE__);
	if (SQL_NUMROWS($result) > 0)
	{
		// List found rallyes
		$SW = 2; $OUT = "";
		while (list($id, $aid, $title, $descr, $templ, $start, $end, $auto_add, $active, $notify, $notified, $min_users, $min_prices) = SQL_FETCHROW($result))
		{
			// Load admin login
			$alogin = GET_ADMIN_LOGIN($aid);

			// Count assigned prices
			$result_prices = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_rallye_prices WHERE rallye_id=%s",
			 array(bigintval($id)), __FILE__, __LINE__);

			// Count joined userids
			$result_user = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_rallye_users WHERE rallye_id=%s",
			 array($id), __FILE__, __LINE__);
			$joined = SQL_NUMROWS($result_user);

			// Did some users joined this rallye?
			if ($joined > 0)
			{
				// List joined users
				$joined = "<A href=\"".URL."/modules.php?module=admin&amp;what=list_rallyes&amp;sub=users&amp;rallye=".$id."\" title=\"".RALLYE_LIST_USERS."\">".$joined."</A>";
			}

			// Alter some variables
			if (empty($alogin)) $alogin = "???";
			if (empty($templ))  $templ  = "---";
			if (empty($descr))  $descr  = "---";

			// Transfer data into array for the template
			$content = array(
				'select'     => "<INPUT type=\"checkbox\" name=\"sel[".$id."]\" class=\"admin_normal\" value=\"1\">",
				'aid'        => $aid,
				'email_link' => CREATE_EMAIL_LINK($aid),
				'alogin'     => $alogin,
				'id'         => $id,
				'sw'         => $SW,
				'title'      => $title,
				'template'   => $templ,
				'joined'     => $joined,
				'start_date' => MAKE_DATETIME($start, "2"),
				'end_date'   => MAKE_DATETIME($end  , "2"),
				'active_lnk' => TRANSLATE_YESNO($active),
				'notify_lnk' => TRANSLATE_YESNO($notify),
				'auto_lnk'   => TRANSLATE_YESNO($auto_add),
				'notified'   => TRANSLATE_YESNO($notified),
				'prices_cnt' => SQL_NUMROWS($result_prices),
				'descr'      => COMPILE_CODE($descr),
				'min_users'  => $min_users,
				'min_prices' => $min_prices,
			);

			// Free memory
			SQL_FREERESULT($result_prices);
			SQL_FREERESULT($result_user);

			// Is the rallye active or not?
			switch ($active)
			{
			case "Y":
				// Rallye is active so do not edit it!
				$content['select'] = "<STRONG class=\"big\">".$id."</STRONG>";
				$content['active_title'] = RALLYE_DEACTIVATE_NOW;
				$content['active'] = 0;
				break;

			case "N":
				$content['active_title'] = RALLYE_ACTIVATE_NOW;
				$content['active'] = "1";
				break;
			}

			// Notification to members?
			switch ($notify)
			{
			case "Y":
				$content['notify_title'] = RALLYE_STOP_NOTIFY_NOW;
				$content['notify'] = 0;
				break;

			case "N":
				$content['notify_title'] = RALLYE_START_NOTIFY_NOW;
				$content['notify'] = "1";
				break;
			}

			// Auto-add of new joined members?
			switch ($auto_add)
			{
			case "Y":
				$content['auto_title'] = RALLYE_STOP_AUTO_ADD_NOW;
				$content['auto'] = 0;
				break;

			case "N":
				$content['auto_title'] = RALLYE_START_AUTO_ADD_NOW;
				$content['auto'] = "1";
				break;
			}

			// Output row
			$OUT .= LOAD_TEMPLATE("admin_list_rallyes_row", true, $content);
			$SW = 3 - $SW;
		}

		// Free memory
		SQL_FREERESULT($result);
		define('__RALLYE_ROWS', $OUT);

		// Load template
		LOAD_TEMPLATE("admin_list_rallyes");
	}
	 else
	{
		// No rallyes setup so far
		LOAD_TEMPLATE("admin_settings_saved", false, RALLYE_NO_RALLYES_SETUP);
	}
}
//
?>
